/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MESA                                                     */
/* Tabela : MESA                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 01/02/2005 - Daniel Lage Guerra                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MESA
BEFORE INSERT OR UPDATE OR DELETE
ON MESA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMESA := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUMESA := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                                         VALUES ('MESA', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';NRMESA='||:OLD.NRMESA||';CDLOJA='||:OLD.CDLOJA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MESA MODIFY DTULTATUMESA DEFAULT SYSDATE
/

UPDATE MESA SET DTULTATUMESA = SYSDATE WHERE DTULTATUMESA IS NULL
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MESA','4.07.020'); END;
/

